(* Debparser *)
(* Copyright 2005-2007 Berke DURAK, INRIA Rocquencourt and The EDOS Project. *)
(* Released under the GNU LGPL version 2. *)

(** Parser for Debian package description files. *)

exception Error of string

(** [napkin_of_fields assoc] parses a Debian package description given by a function
  * [assoc] that takes a field name and returns the first line of the contents of the field. *)
val napkin_of_fields : (string -> string) -> Napkin.default_package

(** Parses the RFC822 row list of a Debian package description *)
val napkin_of_row_list : Rfc822.row list -> Napkin.default_package

(** Creates a stream of row lists from an input channel. *)
val row_list_from_channel : ?tick:(unit -> unit) -> ?warn:(string -> unit) -> in_channel -> Rfc822.row list Stream.t

(** Creates a stream of NAPKINs from an input channel. *)
val from_channel : ?tick:(unit -> unit) -> ?warn:(string -> unit) -> in_channel -> Napkin.channel
