(* Debparser_test *)
(* Copyright 2005-2007 Berke DURAK, INRIA Rocquencourt and The EDOS Project. *)
(* Released under the GNU LGPL version 2. *)

open Napkin;;
module DP = Debparser;;

let _ =
  let fn = Sys.argv.(1) in
  let ic = open_in fn in
  let ps = DP.from_channel
    ~tick:
        begin fun () ->
          Printf.printf "Tick !\n%!"
        end
    ~warn:
        begin fun w ->
          Printf.printf "Warning: %s\n%!" w
        end
    ic
  in
  Stream.iter
    begin fun n ->
      Printf.printf "%s %s on %s\n%!" n.pk_unit n.pk_version
        (match n.pk_architecture with
         | None -> "(none)"
         | Some a -> a)
    end
    ps;
  close_in ic
;;
