(* Test_interpreter *)
(* Copyright 2005-2007 Berke DURAK, INRIA Rocquencourt and The EDOS Project. *)
(* Released under the GNU LGPL version 2. *)

open Conduit
open Rapids
open Interpreter

let _ =
  let db = create_database () in
  let cx = default_cli_context () in
  let cd = stdoutcd in
  let it = create_interpreter db cx cd in
  Ledit.init ();
  Ledit.set_prompt "Master? ";
  while true do
    try
      let l = Ledit.read_line () in
      let q = parse_query l in
      execute_query it q
    with
    | End_of_file ->
        Printf.printf "\nBye.\n%!";
        exit 0
    | x ->
        Printf.printf "Exception: %s\n%!" (Printexc.to_string x)
  done
;;
