(* Command *)
(* The EDOS project                                                 *)
(* Copyright (C)2000-2006 Berke Durak                               *)
(* Released under the GNU Lesser General Public License version 2.1 *)

open Html;;

type html_result = string * Html.html_element
and raw_result = Http.response

type 'result responder =
| Anonymous of (?session:(Users.user * Sessions.session_info) -> Form.t -> 'result)
| Logged_in of (session:(Users.user * Sessions.session_info) -> Form.t -> 'result)

type command =
| Html of html_result responder
| Raw of raw_result responder
;;

exception Redirect of Form.t * string;;

class type bundle =
  object
    method shutdown : unit
    method table : (string * command) list
  end
;;

class virtual generic_bundle =
  object
    method shutdown = ()
  end
;;

type bundle_generator = Db.database -> Configuration.config -> bundle;;
