(* MMap *)

type t

external caml_map : bool -> bool -> int64 -> int64 -> Unix.file_descr -> t = "caml_mmap_map" "caml_mmap_map"

module UL = Unix.LargeFile;;

let map ?(write=false) ?(copy=false) ?(offset=0L) ?length fd =
  let st = UL.fstat fd in
  let length = Int64.sub st.UL.st_size offset in
  caml_map write copy offset length fd
;;

external unmap : t -> unit = "caml_mmap_unmap" "caml_mmap_unmap"
external length : t -> int64 = "caml_mmap_length" "caml_mmap_length"
external offset : t -> int64 = "caml_mmap_offset" "caml_mmap_offset"
external sub : t -> int64 -> int -> string = "caml_mmap_sub" "caml_mmap_sub"
external blit : t -> int64 -> string -> int -> int -> unit = "caml_mmap_blit" "caml_mmap_blit"

let paste mp offset u =
  let n = String.length u in
  blit mp offset u 0 n
;;
