(* Progress *)
(* Copyright 2005-2007 Berke DURAK, INRIA Rocquencourt and The EDOS Project. *)
(* Released under the GNU LGPL version 2. *)
(** A progress indicator module *)

class type progress_indicator =
  object
    method set_label : string -> unit
    method set_decimation : int -> unit
    method display : ?force:bool -> int * int -> unit
    method start : unit
    method finish : unit
    method warn : string -> unit
  end
;;

class indicator : decimation:int -> label:string -> channel:out_channel -> unit -> progress_indicator
class formatter_indicator : decimation:int -> label:string -> fmt:Format.formatter -> unit -> progress_indicator
val dummy : progress_indicator
